#include "GeneratorPolynomialCreator.h"
namespace galois
{

  GeneratorPolynomialCreator::GeneratorPolynomialCreator(GaloisField* _gf, const unsigned int _initial_index, const unsigned int _num_elements)
  {
     if ((_gf != NULL) && (_num_elements != 0))
     {
        gf            = _gf;
        initial_index = _initial_index;
        num_elements  = _num_elements;
     }
     else
     {
        gf            = NULL;
        initial_index = 0;
        num_elements  = 0;
     }
  }

  GaloisFieldPolynomial GeneratorPolynomialCreator::create()
  {
     GaloisFieldElement ALPHA(gf,2);
     GaloisFieldElement xgfe[2] = {GaloisFieldElement(gf, 0),GaloisFieldElement(gf, 1)};
     GaloisFieldPolynomial X(gf,1,xgfe);
     GaloisFieldPolynomial g = GaloisFieldElement(gf, 1);

     for(unsigned int i = initial_index; i < initial_index + num_elements; i++)
     {
          g *= (X + (ALPHA ^ i));
     }

     return g;
  }

}
