/*
  *********************************************************************
  *                                                                   *
  *        Galois Field Arithmetic Library (version 0.0.1)            *
  *                                                                   *
  * Class: Generator Polynomial Creator                               *
  * Version: 0.0.1                                                    *
  * Author: Arash Partow - 2000                                       *
  * URL: http://www.partow.net/projects/galois/index.html             *
  *                                                                   *
  * Copyright Notice:                                                 *
  * Free use of this library is permitted under the guidelines and    *
  * in accordance with the most current version of the Common Public  *
  * License.                                                          *
  * http://www.opensource.org/licenses/cpl.php                        *
  *                                                                   *
  *********************************************************************
*/



#ifndef INCLUDE_GENERATORPOLYNOMIALCREATOR_H
#define INCLUDE_GENERATORPOLYNOMIALCREATOR_H

#include "GaloisField.h"
#include "GaloisFieldElement.h"
#include "GaloisFieldPolynomial.h"


namespace galois
{
   class GeneratorPolynomialCreator
   {
     public:

       GeneratorPolynomialCreator(GaloisField* _gf = NULL, const unsigned int _initial_index = 0, const unsigned int _num_elements = 0);
      ~GeneratorPolynomialCreator(){}

       GaloisFieldPolynomial create();

     private:

       GaloisField* gf;
       unsigned int initial_index;
       unsigned int num_elements;

    };
}

#endif
