/******************* script.h *******************/
#include <stdio.h>
#include <stdlib.h>
#include <iostream>
#include <vector>
#include <list>
#include <cstdlib>
#include <ctime>
#include <fstream>
#include <getopt.h>
#include <math.h>
#include <string.h>
#include <time.h>

#include "GaloisField.h"
#include "GaloisFieldElement.h"
#include "GaloisFieldPolynomial.h"
#include "GeneratorPolynomialCreator.h"

using namespace std;

#define CODING_SPACE 254;
int source_id_ = 0; 
char source_place = 'r';
int nb_nodes_; 
int nb_chunks_ = 10; 
int X_max_ = 100;
int Y_max_ = 100;
int radious_ = 10;
int run_nb = 1;
int losses = 0;
float service_time;
char * directory_results;
int nb_sources = 1;
/*******************************/
int packet_emitted;
int packet_received;
int packet_useful;
int packet_useless;
vector<int> all_chunks_, per_chunk_;

/****************** Parameters for selective.h ******************/
char s_service_time_[100];
char s_completed_clients_[100];
char s_evolution_chunks_[100];
char s_packet_emitted_[100];
char s_packet_useless_[100];

/****************** Parameters for selective_coding.h ******************/
char sc_service_time_[100];
char sc_completed_clients_[100];
char sc_evolution_chunks_[100];
char sc_packet_emitted_[100];
char sc_packet_useless_[100];

/****************** Parameters for blind.h ******************/
char b_service_time_[100];
char b_completed_clients_[100];
char b_evolution_chunks_[100];
char b_packet_emitted_[100];
char b_packet_useless_[100];

/****************** Parameters for blind_coding.h ******************/
char bc_service_time_[100];
char bc_completed_clients_[100];
char bc_evolution_chunks_[100];
char bc_packet_emitted_[100];
char bc_packet_useless_[100];

vector<int> missing_nodes_;   
vector<int> candidates_queue_; 
vector<int> ready_queue_;	   
vector<int> receiving_queue_; 

class node_xy {
 public:
  node_xy();
  ~node_xy();
  int id_;
  double x, y;
  vector<int> list_neighbors_;
};

node_xy::node_xy() {
  this->x=0;
  this->y=0;
  this->list_neighbors_.clear();
}

node_xy::~node_xy() {
  this->x=0;
  this->y=0;
  this->list_neighbors_.clear();
}

vector<node_xy *> list_xy;   
node_xy * source1;
node_xy * source2;
node_xy * source3;
node_xy * source4;

//A Galois Field of type GF(2^8)
//p(x) = 1x^4+1x^3+0x^2+0x^1+1x^0
//       1    1    0    0    1
unsigned int prim_poly[9] = {1,1,1,0,0,0,0,1,1};
galois::GaloisField gf(8,prim_poly);

//D^16+D^15+D^14+D^12+D^11+D^10+D^9+D^8+D^7+D^6+D^5+D^3+D^2+D^1+1
//unsigned int prim_poly[17] = {1,1,1,1,0,1,1,1,1,1,1,1,1,0,1,1,1};
//galois::GaloisField gf(16, prim_poly);
