/*************************** bittorrent.h *************************/
using namespace std;

class s_our_node_;

vector<s_our_node_ *> s_list_nodes_;   

struct s_our_node_ {
public:
  s_our_node_();
  ~s_our_node_();

  int id_, to_transmit_; 
  double x, y; 
  vector<int> list_neighbors_, list_chunks_, just_received_, weight_;

  int independent_nodes();
};

s_our_node_::s_our_node_() {
  this->id_ = 0;
  this->to_transmit_ = 0;
  this->x = 0;
  this->y = 0;
  this->list_chunks_.clear();
  this->list_neighbors_.clear();
  this->just_received_.clear();
  this->weight_.clear();
}

s_our_node_::~s_our_node_() {
  this->id_ = 0;
  this->to_transmit_ = 0;
  this->x = 0;
  this->y = 0;
  this->list_chunks_.clear();
  this->list_neighbors_.clear();
  this->just_received_.clear();
  this->weight_.clear();
} 

int s_our_node_::independent_nodes() {
  bool test_ = true;

  for (int i=0; i<this->list_neighbors_.size(); i++) {
    s_our_node_ * neighbor_;
    neighbor_ = s_list_nodes_[this->list_neighbors_[i]];
    for (int j=0; j<this->list_chunks_.size(); j++) {
      test_ = true;
      if (neighbor_->list_chunks_.size() < nb_chunks_) {
	for (int k=0; k<neighbor_->list_chunks_.size(); k++) {
	  if (this->list_chunks_[j] == neighbor_->list_chunks_[k]) {
	    test_ = false;
	    break;
	  }
	}
      } else {test_ = false;}
      if (test_ == true) {
	this->weight_[j] = this->weight_[j] + 1;
      }
    }
  }
  int max_ = 0, index_ = 0;
  for (int i=0; i<this->weight_.size(); i++) {
    if (max_ < this->weight_[i]) {
      max_ = this->weight_[i];
      index_ = i;
    }
  }
  if (max_ > 0) {
    this->to_transmit_ = this->list_chunks_[index_];
    for (int j=0; j<this->list_chunks_.size(); j++) {
      this->weight_[j] = 0;
    }
    return 1;
  }
  else {return 0;}
}

void s_create_nodes_() {
  for (int i=0; i<nb_nodes_; i++) {
    s_our_node_ *new_node_ = new s_our_node_();
    new_node_->id_ = i;
    s_list_nodes_.push_back(new_node_);
    if (
	((nb_sources == 1) && i!=source1->id_) || 
	((nb_sources == 2) && i!=source1->id_ && i!=source2->id_) || 
	((nb_sources == 3) && i!=source1->id_ && i!=source2->id_ && i!=source3->id_) || 
	((nb_sources == 4) && i!=source1->id_ && i!=source2->id_ && i!=source3->id_ && i!=source4->id_) 
	) {
      missing_nodes_.push_back(i);
    }
    else {
      candidates_queue_.push_back(i);
      for (int j=0; j<nb_chunks_; j++) {
 	new_node_->list_chunks_.push_back(j);
	new_node_->weight_.push_back(0);
      }
    }
  }
}

void s_generate_xy() {
  s_our_node_ * node1;
  node_xy * node2;

  for (int i=0; i<nb_nodes_; i++) {
    node1 = s_list_nodes_[i];
    node2 = list_xy[i];
    node1->x = node2->x;
    node1->y = node2->y;
    for (int j=0; j<node2->list_neighbors_.size(); j++) {
      node1->list_neighbors_.push_back(node2->list_neighbors_[j]);
    }
  }
}

void  s_select_transmitters() {
  vector<int>::iterator iter_int_;
  vector<int> potential_transmitters_;
  
  for (int p=0; p<candidates_queue_.size(); p++) {
    s_our_node_ * node_;
    node_ = s_list_nodes_[candidates_queue_[p]];
    if (node_->independent_nodes() == 0) {
      p--;
      vector<int>::iterator start = candidates_queue_.begin();
      vector<int>::iterator end = candidates_queue_.end();
      iter_int_ = find(start, end, node_->id_);
      candidates_queue_.erase(iter_int_);
    }
  }
  potential_transmitters_ = candidates_queue_;  

  while (potential_transmitters_.size() > 0) {
    
    int j = int((double(rand())/RAND_MAX)*potential_transmitters_.size());
    int k = potential_transmitters_[j];
    ready_queue_.push_back(k);
    s_our_node_ * selected_node_;
    selected_node_ = s_list_nodes_[k];

    vector<int>::iterator start;
    vector<int>::iterator end;

    vector<int> to_remove;
    to_remove.clear();
    to_remove.push_back(k);
    for (j=0;j<selected_node_->list_neighbors_.size(); j++) {
      int neighbor_id = selected_node_->list_neighbors_[j];
      s_our_node_ * neighbor_ = s_list_nodes_[neighbor_id];
      start = to_remove.begin();
      end = to_remove.end();
      iter_int_ = find(start, end, neighbor_id);
      if (iter_int_ == to_remove.end()) {to_remove.push_back(neighbor_id);}
      for (k=0;k<neighbor_->list_neighbors_.size(); k++) {
	int new_id = neighbor_->list_neighbors_[k];
	start = to_remove.begin();
	end = to_remove.end();
	iter_int_ = find(start, end, new_id);
	if (iter_int_ == to_remove.end()) {to_remove.push_back(new_id);}
      }
    }      
    while(to_remove.size() > 0) {
      int removed_node = to_remove[0];
      iter_int_ = to_remove.begin();
      to_remove.erase(iter_int_);
      start = potential_transmitters_.begin();
      end = potential_transmitters_.end();
      iter_int_ = find(start, end, removed_node);
      if (iter_int_ != potential_transmitters_.end()) {potential_transmitters_.erase(iter_int_);}
    }
  }
  
  potential_transmitters_.clear();
}

void s_perform_transmission() {
  
  vector<int>::iterator iter_int_;
  while (ready_queue_.size() > 0) {
    int j;
    s_our_node_ * transmitter_;
    
    j = ready_queue_[0];
    iter_int_ = ready_queue_.begin();
    ready_queue_.erase(iter_int_);

    transmitter_ = s_list_nodes_[j];
    packet_emitted++;
    int transmitted_chunk_; 
    transmitted_chunk_ = transmitter_->to_transmit_;
    
    for (j=0; j<transmitter_->list_neighbors_.size(); j++) {
      int proba = int((double(rand())/RAND_MAX)*100.0 + 1);
      if (proba > losses) {
	int neighbor_id_ = transmitter_->list_neighbors_[j];
	s_our_node_ * neighbor_ = s_list_nodes_[neighbor_id_];
	if (neighbor_->list_chunks_.size() < nb_chunks_) {
	  neighbor_->just_received_.push_back(transmitted_chunk_); 
	  vector<int >::iterator start = receiving_queue_.begin();
	  vector<int>::iterator end = receiving_queue_.end();
	  iter_int_ = find(start, end, neighbor_id_); 
	  
	  if (iter_int_ == receiving_queue_.end()) {
	    receiving_queue_.push_back(neighbor_id_);
	  }
	}
      }
    }
  }
}

void s_update_nodes() {
  while (receiving_queue_.size() > 0) {
    int node_id_ = receiving_queue_[0];
    s_our_node_ * current_node_ = s_list_nodes_[node_id_];
    vector<int>::iterator iter_int_;
    packet_received++;
    if (current_node_->just_received_.size() > 1) {
      current_node_->just_received_.clear();
    }
    else {
      int received_chunk_ = current_node_->just_received_[0];
      bool new_chunk_ = true;
      for (int i=0; i<current_node_->list_chunks_.size(); i++) {
	if (received_chunk_ == current_node_->list_chunks_[i]) {
	  new_chunk_ = false;
	  break;
	}
      }
      if (new_chunk_ == true) {
	packet_useful++;
 	current_node_->list_chunks_.push_back(received_chunk_);
	current_node_->weight_.push_back(0);
 	if (current_node_->list_chunks_.size() == nb_chunks_) {
 	  vector<int>::iterator start = missing_nodes_.begin();
 	  vector<int>::iterator end = missing_nodes_.end();
 	  iter_int_ = find(start, end, node_id_);
 	  if (iter_int_ != missing_nodes_.end()) 
 	    {missing_nodes_.erase(iter_int_);}
 	}
	vector<int>::iterator start = candidates_queue_.begin();
	vector<int>::iterator end = candidates_queue_.end();
	iter_int_ = find(start, end, node_id_);
	if (iter_int_ == candidates_queue_.end()) {
	  candidates_queue_.push_back(node_id_);
	}
      }
      current_node_->just_received_.clear();
    }
    iter_int_ = receiving_queue_.begin();
    receiving_queue_.erase(iter_int_);
  }
}

void run_selective() {
  service_time = 0;
  packet_emitted = 0;
  packet_received = 0;
  packet_useful = 0;
  packet_useless = 0;

  missing_nodes_.clear();
  ready_queue_.clear();
  candidates_queue_.clear();
  receiving_queue_.clear();
  s_list_nodes_.clear();
  all_chunks_.clear();
  for (int a=0; a<nb_chunks_; a++) {
    all_chunks_.push_back(0);
  }
  all_chunks_.push_back(1);

  char temp_s_service_time_[100];
  char temp_s_completed_clients_[100];
  char temp_s_evolution_chunks_[100];
  char temp_s_packet_emitted_[100];
  char temp_s_packet_useless_[100];

  if (source_place == 'r') {

    strcpy(temp_s_service_time_,s_service_time_);
    if (nb_sources == 1) {
      strcat(temp_s_service_time_,"_r.m");
    } 
    if (nb_sources == 2) {
      strcat(temp_s_service_time_,"_2r.m");
    }
    if (nb_sources == 3) {
      strcat(temp_s_service_time_,"_3r.m");
    }
    if (nb_sources == 4) {
      strcat(temp_s_service_time_,"_4r.m");
    }

    strcpy(temp_s_completed_clients_,s_completed_clients_);
    if (nb_sources == 1) {
      strcat(temp_s_completed_clients_,"_r.m");
    } 
    if (nb_sources == 2) {
      strcat(temp_s_completed_clients_,"_2r.m");
    }
    if (nb_sources == 3) {
      strcat(temp_s_completed_clients_,"_3r.m");
    }
    if (nb_sources == 4) {
      strcat(temp_s_completed_clients_,"_4r.m");
    }

    strcpy(temp_s_evolution_chunks_,s_evolution_chunks_);
    if (nb_sources == 1) {
      strcat(temp_s_evolution_chunks_,"_r.m");
    } 
    if (nb_sources == 2) {
      strcat(temp_s_evolution_chunks_,"_2r.m");
    }
    if (nb_sources == 3) {
      strcat(temp_s_evolution_chunks_,"_3r.m");
    }
    if (nb_sources == 4) {
      strcat(temp_s_evolution_chunks_,"_4r.m");
    }

    strcpy(temp_s_packet_emitted_,s_packet_emitted_);
    if (nb_sources == 1) {
    strcat(temp_s_packet_emitted_,"_r.m");
    } 
    if (nb_sources == 2) {
    strcat(temp_s_packet_emitted_,"_2r.m");
    }
    if (nb_sources == 3) {
    strcat(temp_s_packet_emitted_,"_3r.m");
    }
    if (nb_sources == 4) {
    strcat(temp_s_packet_emitted_,"_4r.m");
    }

    strcpy(temp_s_packet_useless_,s_packet_useless_);
    if (nb_sources == 1) {
      strcat(temp_s_packet_useless_,"_r.m");
    } 
    if (nb_sources == 2) {
      strcat(temp_s_packet_useless_,"_2r.m");
    }
    if (nb_sources == 3) {
      strcat(temp_s_packet_useless_,"_3r.m");
    }
    if (nb_sources == 4) {
      strcat(temp_s_packet_useless_,"_4r.m");
    }
  }

  if (source_place == 'e') {

    strcpy(temp_s_service_time_,s_service_time_);
    if (nb_sources == 1) {
      strcat(temp_s_service_time_,"_e.m");
    } 
    if (nb_sources == 2) {
      strcat(temp_s_service_time_,"_2e.m");
    }
    if (nb_sources == 3) {
      strcat(temp_s_service_time_,"_3e.m");
    }
    if (nb_sources == 4) {
      strcat(temp_s_service_time_,"_4e.m");
    }

    strcpy(temp_s_completed_clients_,s_completed_clients_);
    if (nb_sources == 1) {
      strcat(temp_s_completed_clients_,"_e.m");
    } 
    if (nb_sources == 2) {
      strcat(temp_s_completed_clients_,"_2e.m");
    }
    if (nb_sources == 3) {
      strcat(temp_s_completed_clients_,"_3e.m");
    }
    if (nb_sources == 4) {
      strcat(temp_s_completed_clients_,"_4e.m");
    }

    strcpy(temp_s_evolution_chunks_,s_evolution_chunks_);
    if (nb_sources == 1) {
      strcat(temp_s_evolution_chunks_,"_e.m");
    } 
    if (nb_sources == 2) {
      strcat(temp_s_evolution_chunks_,"_2e.m");
    }
    if (nb_sources == 3) {
      strcat(temp_s_evolution_chunks_,"_3e.m");
    }
    if (nb_sources == 4) {
      strcat(temp_s_evolution_chunks_,"_4e.m");
    }

    strcpy(temp_s_packet_emitted_,s_packet_emitted_);
    if (nb_sources == 1) {
    strcat(temp_s_packet_emitted_,"_e.m");
    } 
    if (nb_sources == 2) {
    strcat(temp_s_packet_emitted_,"_2e.m");
    }
    if (nb_sources == 3) {
    strcat(temp_s_packet_emitted_,"_3e.m");
    }
    if (nb_sources == 4) {
    strcat(temp_s_packet_emitted_,"_4e.m");
    }

    strcpy(temp_s_packet_useless_,s_packet_useless_);
    if (nb_sources == 1) {
      strcat(temp_s_packet_useless_,"_e.m");
    } 
    if (nb_sources == 2) {
      strcat(temp_s_packet_useless_,"_2e.m");
    }
    if (nb_sources == 3) {
      strcat(temp_s_packet_useless_,"_3e.m");
    }
    if (nb_sources == 4) {
      strcat(temp_s_packet_useless_,"_4e.m");
    }
  }

  ofstream time_slot(temp_s_service_time_, ios::out);
  if (!time_slot) {
    cerr << "the file service_time_ could not be opened" << endl;
  }
  time_slot << "time_slot = [";

  ofstream completed_clients_(temp_s_completed_clients_, ios::out);
  if (!completed_clients_) {
    cerr << "the file s_completed_clients_ could not be opened" << endl;
  }
  completed_clients_ << "s_completed_clients_ = [";

  ofstream out_allchunks(temp_s_evolution_chunks_, ios::out);
  if (!out_allchunks) {
    cerr << "the file evolution_chunks could not be opened" << endl;
  }
  out_allchunks << "s_evolution_chunks_ = [";

  ofstream packet_emitted_(temp_s_packet_emitted_, ios::out);
  if (!packet_emitted_) {
    cerr << "the file packet_emitted could not be opened" << endl;
  }
  packet_emitted_ << "s_packet_emitted_ =[";
  
  ofstream packet_useless_(temp_s_packet_useless_, ios::out);
  if (!packet_useless_) {
    cerr << "the file packet_useless_ could not be opened" << endl;
  }
  packet_useless_ << "s_packet_useless_ = [";
  
  s_create_nodes_();
  s_generate_xy();
  
  cout << "\n________________________" << endl;
  cout << "start selective" << endl;
  while ((missing_nodes_.size() > 0) && (candidates_queue_.size() > 0)) {
    cout << "run s_selected_transmitters" << endl;
    s_select_transmitters();
    cout << "run s_perform_transmission" << endl;
    s_perform_transmission();
    cout << "run s_update_nodes" << endl;
    s_update_nodes();
    
    service_time = service_time + 1.0/nb_chunks_;

    for (int a=1; a<nb_nodes_; a++) {
      s_our_node_ * node_;
      node_ = s_list_nodes_[a];
      int temp_ = node_->list_chunks_.size();
      all_chunks_[temp_] = all_chunks_[temp_] + 1;
    }
    for (int a=0; a<nb_chunks_+1; a++) {
      out_allchunks << all_chunks_[a] << " ";
      all_chunks_[a]=0;
    }
    out_allchunks << endl;
    
    completed_clients_ << nb_nodes_ - missing_nodes_.size() << " ";
    packet_emitted_ << packet_emitted  << " ";
    packet_useless_ << packet_received - packet_useful  << " ";
    time_slot << service_time << " ";
  }
  cout << "end of selective\n" << endl;
  time_slot << "]; \n\n";
  time_slot.close();
  completed_clients_ << "]; \n\n";
  completed_clients_.close();
  out_allchunks << "]; \n\n";
  out_allchunks.close();
  packet_emitted_ << "]; \n\n";
  packet_emitted_.close();
  packet_useless_ << "]; \n\n";
  packet_useless_.close();

  for (int i=0; i<nb_nodes_; i++) {
    delete s_list_nodes_[i];
  }

  missing_nodes_.clear();
  ready_queue_.clear();
  candidates_queue_.clear();
  receiving_queue_.clear();
  s_list_nodes_.clear();

}
